//+------------------------------------------------------------------+
//|                                                          M_L.mq4 |
//|                                                     Sokolov Oleg |
//|                                                o_sokolov@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Sokolov Oleg"
#property link      "o_sokolov@mail.ru"

#property indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Red
#property  indicator_width1  2
//---- indicator parameters
extern int FastLWMA=29;
extern int SlowLWMA=81;
extern int labels_width=1;
extern color _color=Lime;
//extern int SignalSMA=9;
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];

// --
string n.lastmetka = "LastMetka";
color  c.lastmetka = Yellow;
int    w.lastmetka = 3;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
 //  SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("M_L("+FastLWMA+","+SlowLWMA+")");
   SetIndexLabel(0,"MACD");
   //SetIndexLabel(1,"Signal");
//---- initialization done
   return(0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(ObjectFind("macd")!=-1) ObjectDelete("macd");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
//----
 int limit;
   int counted_bars=IndicatorCounted();
    datetime time;
 time=iTime(Symbol(),Period(),0);

//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
    {
      MacdBuffer[i]=iMA(NULL,0,FastLWMA,0,MODE_LWMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowLWMA,0,MODE_LWMA,PRICE_CLOSE,i);
  ObjectCreate("macd",OBJ_ARROW,WindowFind("M_L("+FastLWMA+","+SlowLWMA+")"),time,MacdBuffer[i],time,MacdBuffer[i]);
  ObjectSet("macd",OBJPROP_ARROWCODE,6);
  ObjectSet("macd",OBJPROP_WIDTH,labels_width);
  ObjectSet("macd",OBJPROP_COLOR,_color);
  //ObjectSet("macd",OBJPROP_PRICE1,MacdBuffer[i]);

  }
   return(0);
  }
//+------------------------------------------------------------------+

 

